package ch.zhaw.pm2.multichat.client;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class ClientMessageList {
    private final List<Message> messages = new ArrayList<>();
	private final ChatWindowController gui;

	public ClientMessageList(ChatWindowController gui) {
		this.gui = gui;
	}

    public void addMessage(Message message) {
	    messages.add(message);
    }

	public void writeFilteredMessages(String filter) {
		boolean showAll = filter == null || filter.isBlank();
		gui.clearMessageArea();
		for(Message message : messages) {
			if(showAll ||
					message.getSender().contains(filter) ||
					message.getReceiver().contains(filter) ||
					message.getText().contains(filter))
			{
			    switch (message.getType()) {
                    case MESSAGE: gui.writeMessage(message.getSender(), message.getReceiver(), message.getText()); break;
                    case ERROR: gui.writeError(message.getText()); break;
                    case INFO: gui.writeInfo(message.getText()); break;
                    default: gui.writeError("Unexpected message type: " + message.getType());
                }
			}
		}
	}

}
